'***************************************
'* PIC12F675 RC SERVO contoroller   *
'***************************************
define OSC 20
define ADC_BITS		10
define ADC_CLOCK	3
define ADC_SAMPLE	50

'       76543210
TRISIO=%00000011    'GP0,GP1 input
CMCON =%00000111    'disable comparator
ADCON0=%11000011    'GP1 - Vreff
ANSEL =%00110011    'GP0,GP1 analog input

pulse	var		GPIO.2
low pulse

'***************************************
'* 0.6m sec  -> 1.5m sec  ->  2.4m sec
'*    +90        center       -90
'* pulseout pin,val (20MHz)
'*val 300         750        1200  * 2 maicro 
width   var     word
adval   var     word
adcdat  var     word
sum     var     word
i       var     byte
'***************************************

OPTION_REG = %01010111
INTCON     = %10100000
ON interrupt goto t_warikomi

LOOP:
   sum=0
   for i=1 to 30         
    ADCIN 0,adcdat
    sum=sum+adcdat
   next i 
    adval=sum/30

   width = ((1023-adval)*12)/14 +327

GOTO LOOP

Disable

t_warikomi:
'*********************************
'* interval time = 16mS
'*********************************
    
    pulsout pulse,width

    INTCON.2=0
    RESUME
Enable
end

